//------------------------------------------------------------------------------
// <auto-generated>
//     This code was auto-generated by com.unity.inputsystem:InputActionCodeGenerator
//     version 1.7.0
//     from Packages/com.game-savvy.outools/Runtime/Utilities/FreelookCamera/FreelookCameraInputActions.inputactions
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.InputSystem;
using UnityEngine.InputSystem.Utilities;

namespace GameSavvy.OpenUnityTools.FreelookCameras
{
    public partial class @FreelookCameraInputActions: IInputActionCollection2, IDisposable
    {
        public InputActionAsset asset { get; }
        public @FreelookCameraInputActions()
        {
            asset = InputActionAsset.FromJson(@"{
    ""name"": ""FreelookCameraInputActions"",
    ""maps"": [
        {
            ""name"": ""FreelookCamera"",
            ""id"": ""194fc14b-b835-41b7-96cb-847830254658"",
            ""actions"": [
                {
                    ""name"": ""Look"",
                    ""type"": ""Value"",
                    ""id"": ""f32c9b68-cbec-40f4-b916-298d31293fd6"",
                    ""expectedControlType"": ""Vector2"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": true
                },
                {
                    ""name"": ""EnableMovement"",
                    ""type"": ""Button"",
                    ""id"": ""e10c3f27-a7d8-4d55-9fb9-0f01ec511bd9"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""Move"",
                    ""type"": ""Value"",
                    ""id"": ""57b8e621-55ca-4e60-99ab-c565360da053"",
                    ""expectedControlType"": ""Vector3"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": true
                },
                {
                    ""name"": ""MoveFast"",
                    ""type"": ""Button"",
                    ""id"": ""4423ad52-c968-463e-9811-220832202bd4"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""Panning2DButton"",
                    ""type"": ""Button"",
                    ""id"": ""8e6c9adc-a900-49d7-98ec-94347e438206"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                },
                {
                    ""name"": ""SpeedModifier"",
                    ""type"": ""Value"",
                    ""id"": ""576f475b-f57e-4459-afcd-9f6fbc8d1b58"",
                    ""expectedControlType"": ""Vector2"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": true
                }
            ],
            ""bindings"": [
                {
                    ""name"": """",
                    ""id"": ""fab306e9-efa8-4be2-82c6-530dae1a9e63"",
                    ""path"": ""<Mouse>/rightButton"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""EnableMovement"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""cc1dbc17-c659-4e61-87c6-ebbec94b5b7c"",
                    ""path"": ""<Keyboard>/leftShift"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""MoveFast"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""5227c672-f47b-46e3-b380-887bda8137f8"",
                    ""path"": ""<Mouse>/delta"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Look"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": ""3D Vector"",
                    ""id"": ""de211a74-2bd6-490d-9471-5a6f50464023"",
                    ""path"": ""3DVector"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Move"",
                    ""isComposite"": true,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": ""up"",
                    ""id"": ""304ce8ee-7361-4308-a583-0e69e623c452"",
                    ""path"": ""<Keyboard>/e"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Move"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""down"",
                    ""id"": ""714717d5-c3f1-4b76-83e0-ae493dcf2702"",
                    ""path"": ""<Keyboard>/q"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Move"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""left"",
                    ""id"": ""bfaf64cc-8f06-4414-8cbd-11184a1bafc7"",
                    ""path"": ""<Keyboard>/a"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Move"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""right"",
                    ""id"": ""e3361e8f-4249-4d2f-bb91-6e5123c219a2"",
                    ""path"": ""<Keyboard>/d"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Move"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""forward"",
                    ""id"": ""803da006-19e8-4919-890f-de7c66cd97b0"",
                    ""path"": ""<Keyboard>/w"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Move"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": ""backward"",
                    ""id"": ""efc1d49b-8c0a-4583-9235-613f81527ec1"",
                    ""path"": ""<Keyboard>/s"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Move"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": true
                },
                {
                    ""name"": """",
                    ""id"": ""0ed4027e-b690-42d5-a1ae-9f066c2b0ef1"",
                    ""path"": ""<Mouse>/middleButton"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""Panning2DButton"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                },
                {
                    ""name"": """",
                    ""id"": ""e5038514-2a2f-4ad2-ae42-039865ae521a"",
                    ""path"": ""<Mouse>/scroll"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""SpeedModifier"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                }
            ]
        }
    ],
    ""controlSchemes"": []
}");
            // FreelookCamera
            m_FreelookCamera = asset.FindActionMap("FreelookCamera", throwIfNotFound: true);
            m_FreelookCamera_Look = m_FreelookCamera.FindAction("Look", throwIfNotFound: true);
            m_FreelookCamera_EnableMovement = m_FreelookCamera.FindAction("EnableMovement", throwIfNotFound: true);
            m_FreelookCamera_Move = m_FreelookCamera.FindAction("Move", throwIfNotFound: true);
            m_FreelookCamera_MoveFast = m_FreelookCamera.FindAction("MoveFast", throwIfNotFound: true);
            m_FreelookCamera_Panning2DButton = m_FreelookCamera.FindAction("Panning2DButton", throwIfNotFound: true);
            m_FreelookCamera_SpeedModifier = m_FreelookCamera.FindAction("SpeedModifier", throwIfNotFound: true);
        }

        public void Dispose()
        {
            UnityEngine.Object.Destroy(asset);
        }

        public InputBinding? bindingMask
        {
            get => asset.bindingMask;
            set => asset.bindingMask = value;
        }

        public ReadOnlyArray<InputDevice>? devices
        {
            get => asset.devices;
            set => asset.devices = value;
        }

        public ReadOnlyArray<InputControlScheme> controlSchemes => asset.controlSchemes;

        public bool Contains(InputAction action)
        {
            return asset.Contains(action);
        }

        public IEnumerator<InputAction> GetEnumerator()
        {
            return asset.GetEnumerator();
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        public void Enable()
        {
            asset.Enable();
        }

        public void Disable()
        {
            asset.Disable();
        }

        public IEnumerable<InputBinding> bindings => asset.bindings;

        public InputAction FindAction(string actionNameOrId, bool throwIfNotFound = false)
        {
            return asset.FindAction(actionNameOrId, throwIfNotFound);
        }

        public int FindBinding(InputBinding bindingMask, out InputAction action)
        {
            return asset.FindBinding(bindingMask, out action);
        }

        // FreelookCamera
        private readonly InputActionMap m_FreelookCamera;
        private List<IFreelookCameraActions> m_FreelookCameraActionsCallbackInterfaces = new List<IFreelookCameraActions>();
        private readonly InputAction m_FreelookCamera_Look;
        private readonly InputAction m_FreelookCamera_EnableMovement;
        private readonly InputAction m_FreelookCamera_Move;
        private readonly InputAction m_FreelookCamera_MoveFast;
        private readonly InputAction m_FreelookCamera_Panning2DButton;
        private readonly InputAction m_FreelookCamera_SpeedModifier;
        public struct FreelookCameraActions
        {
            private @FreelookCameraInputActions m_Wrapper;
            public FreelookCameraActions(@FreelookCameraInputActions wrapper) { m_Wrapper = wrapper; }
            public InputAction @Look => m_Wrapper.m_FreelookCamera_Look;
            public InputAction @EnableMovement => m_Wrapper.m_FreelookCamera_EnableMovement;
            public InputAction @Move => m_Wrapper.m_FreelookCamera_Move;
            public InputAction @MoveFast => m_Wrapper.m_FreelookCamera_MoveFast;
            public InputAction @Panning2DButton => m_Wrapper.m_FreelookCamera_Panning2DButton;
            public InputAction @SpeedModifier => m_Wrapper.m_FreelookCamera_SpeedModifier;
            public InputActionMap Get() { return m_Wrapper.m_FreelookCamera; }
            public void Enable() { Get().Enable(); }
            public void Disable() { Get().Disable(); }
            public bool enabled => Get().enabled;
            public static implicit operator InputActionMap(FreelookCameraActions set) { return set.Get(); }
            public void AddCallbacks(IFreelookCameraActions instance)
            {
                if (instance == null || m_Wrapper.m_FreelookCameraActionsCallbackInterfaces.Contains(instance)) return;
                m_Wrapper.m_FreelookCameraActionsCallbackInterfaces.Add(instance);
                @Look.started += instance.OnLook;
                @Look.performed += instance.OnLook;
                @Look.canceled += instance.OnLook;
                @EnableMovement.started += instance.OnEnableMovement;
                @EnableMovement.performed += instance.OnEnableMovement;
                @EnableMovement.canceled += instance.OnEnableMovement;
                @Move.started += instance.OnMove;
                @Move.performed += instance.OnMove;
                @Move.canceled += instance.OnMove;
                @MoveFast.started += instance.OnMoveFast;
                @MoveFast.performed += instance.OnMoveFast;
                @MoveFast.canceled += instance.OnMoveFast;
                @Panning2DButton.started += instance.OnPanning2DButton;
                @Panning2DButton.performed += instance.OnPanning2DButton;
                @Panning2DButton.canceled += instance.OnPanning2DButton;
                @SpeedModifier.started += instance.OnSpeedModifier;
                @SpeedModifier.performed += instance.OnSpeedModifier;
                @SpeedModifier.canceled += instance.OnSpeedModifier;
            }

            private void UnregisterCallbacks(IFreelookCameraActions instance)
            {
                @Look.started -= instance.OnLook;
                @Look.performed -= instance.OnLook;
                @Look.canceled -= instance.OnLook;
                @EnableMovement.started -= instance.OnEnableMovement;
                @EnableMovement.performed -= instance.OnEnableMovement;
                @EnableMovement.canceled -= instance.OnEnableMovement;
                @Move.started -= instance.OnMove;
                @Move.performed -= instance.OnMove;
                @Move.canceled -= instance.OnMove;
                @MoveFast.started -= instance.OnMoveFast;
                @MoveFast.performed -= instance.OnMoveFast;
                @MoveFast.canceled -= instance.OnMoveFast;
                @Panning2DButton.started -= instance.OnPanning2DButton;
                @Panning2DButton.performed -= instance.OnPanning2DButton;
                @Panning2DButton.canceled -= instance.OnPanning2DButton;
                @SpeedModifier.started -= instance.OnSpeedModifier;
                @SpeedModifier.performed -= instance.OnSpeedModifier;
                @SpeedModifier.canceled -= instance.OnSpeedModifier;
            }

            public void RemoveCallbacks(IFreelookCameraActions instance)
            {
                if (m_Wrapper.m_FreelookCameraActionsCallbackInterfaces.Remove(instance))
                    UnregisterCallbacks(instance);
            }

            public void SetCallbacks(IFreelookCameraActions instance)
            {
                foreach (var item in m_Wrapper.m_FreelookCameraActionsCallbackInterfaces)
                    UnregisterCallbacks(item);
                m_Wrapper.m_FreelookCameraActionsCallbackInterfaces.Clear();
                AddCallbacks(instance);
            }
        }
        public FreelookCameraActions @FreelookCamera => new FreelookCameraActions(this);
        public interface IFreelookCameraActions
        {
            void OnLook(InputAction.CallbackContext context);
            void OnEnableMovement(InputAction.CallbackContext context);
            void OnMove(InputAction.CallbackContext context);
            void OnMoveFast(InputAction.CallbackContext context);
            void OnPanning2DButton(InputAction.CallbackContext context);
            void OnSpeedModifier(InputAction.CallbackContext context);
        }
    }
}
